/***************************************************************************
                          agconfig.h  -  description
                             -------------------
    begin                : Fri Mar 30 2001
    copyright            : (C) 2001 by Joe Theriault
    email                : uallloveme@yahoo.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef AGCONFIG_H
#define AGCONFIG_H

#include <qfile.h>
#include <qlist.h>
#include <qstring.h>
#include <qstringlist.h>

class AGConfig
{
 public:
  AGConfig(QString ag_directory, bool readConfig = true);

  bool           hasChanged();
  QString      getAGDir();
  QString      getName();
  QString      getPass();
  QString      getDLDir();
  QStringList getShares();
  
  bool read();
  bool write();
  void setAGDir(QString newAGDir);
  void setName(QString newName);
  void setPass(QString newPass);
  void setDLDir(QString newDLDir);
  void setShares(QStringList newShares);
  
 private:
  bool changed;
  
  QString name,
             pass,
             dl_dir,
             ag_dir;
  
  QFile account_file,
          shares_file;

  QStringList shares;
};

#endif
